package ACL2::Proceso::Descartar;
use base ACL2::Proceso;

=head1 NAME

ACL2::Proceso::Descartar - ACL2 descarta algunos tE<eacute>rminos que cree redundantes

=head1 FUNCTIONS

=cut

#
#    Clase Descartar: ACL2 descarta algunos términos que cree redundantes
#
#    Copyright (C) 2006-2008 Antonio García Domínguez
#    $Id: Descartar.pm 202 2008-06-27 22:47:53Z bluezio $
#
#    This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

use strict;
use warnings;
use ACL2::Orden;
use ACL2::Proceso::Fabrica;

BEGIN {
ACL2::Proceso::Fabrica->registrar
    (
     __PACKAGE__,
     sub {
	 return ACL2::Proceso::Descartar->_identificar(@_);
     }
     );
}

sub escribir_xml_cabecera {
    my ($this, $writer) = @_;

    $writer->startTag(ACL2::Tags::DISCARD_TAG,
		      "discarded" => $this->{termino});
    ACL2::Orden->salida_parrafos($writer, $this->{salida});
}

sub escribir_xml_final {
    my ($this, $writer) = @_;
    $writer->endTag(ACL2::Tags::DISCARD_TAG);
}

sub _identificar
{
    my ($paquete, $salida) = @_;
    my %res      = ();

    $salida =~ /^\s*(?-x:We suspect that the term (.*?) is irrelevant to the truth )
	(?-x:of this conjecture and throw it out\.)/ox
	or return undef;

    $res{termino} = $1;
    $res{salida} = substr $salida, $-[0], $+[0] - $-[0];

    return \%res;
}

1;
